//
// otclTest.C
//
// Package header for Otcl test shared library
//
// 1996sep30 dpwe@icsi.berkeley.edu
//

#include "Otcl.H"

#include "Test_cdl.H"
#include "mtest_cdl.H"

extern "C" int Otcltest_Init(Tcl_Interp *interp);

extern Otcl *globalOtclPtr;	// defined for us in Otcl.C

//Otcl *globalOtclPtr=NULL;

#include <iostream.h>

int Otcltest_Init(Tcl_Interp *interp)
{
    int rc = TCL_OK;

    cerr << "Otcltest_Init start" << endl;
    /* We assume that Otcl has already been loaded! */
    if(globalOtclPtr==NULL) {
	cerr << "Otcltest_Init: You must load the Otcl core first" << endl;
	return TCL_ERROR;
    } else {
	// Get the address of the base otcl interpreter via tcl
	int code = Tcl_Eval(interp, "otcl _ptr");
	if (code != TCL_OK) {
	    Tcl_AppendResult(interp, "Otcltest_Init: couldn't find Otcl", NULL);
	    return TCL_ERROR;
	}
	// Else, result was hex address of Otcl
//	sscanf(interp->result, "%lx", &globalOtclPtr);

#ifdef SHLIB_NO_STATIC_INIT
	// Have to explicitly initialize each package item here
	SimpleCppClass_Init(interp);
	TestCppClass_Init(interp);
	Thing_Init(interp);
	ThingC_Init(interp);
	System_Init(interp);
	SlotTest_Init(interp);
	InheritTest_Init(interp);
	ReturnableObj_Init(interp);
	ObjRtnTest_Init(interp);
	ObjPassTest_Init(interp);
	DefaultValTest_Init(interp);
	FakeSlotTest_Init(interp);
	FakeConstrArgs_Init(interp);
	TclAlias_Init(interp);
#endif /* SHLIB_NO_STATIC_INIT */

	// Hit "otcl clear" to ensure rebuilding of class table
	rc = Tcl_Eval(interp, "otcl clear");

    cerr << "Otcltest_Init done" << endl;
	return rc;
    }
}

